Bug 1467132 - Review Request: json-c12 - JSON implementation in C
Review Request: json-c12 - JSON implementation in C
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
unspecified Severity medium
: ---
: ---
Assigned To: Björn "besser82" Esser
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2017-07-02 21:31 EDT by jeffrey.lau
Modified: 2017-08-03 21:16 EDT (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2017-07-23 14:49:45 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
besser82: fedora‑review+


Attachments (Terms of Use)

  None (edit)
Description jeffrey.lau 2017-07-02 21:31:39 EDT
Spec URL: https://raw.githubusercontent.com/riboseinc/rpm-specs/master/json-c12/json-c12.spec
SRPM URL: https://github.com/riboseinc/yum/blob/master/SRPMS/json-c12-0.12.1-2.src.rpm
Description: JSON implementation in C
Fedora Account System Username: jeffreylauribose
Comment 1 jeffrey.lau 2017-07-02 21:59:51 EDT
Spec URL: https://raw.githubusercontent.com/riboseinc/rpm-specs/master/json-c12/json-c12.spec
SRPM URL: https://raw.githubusercontent.com/riboseinc/yum/master/SRPMS/json-c12-0.12.1-2.src.rpm
Description: JSON implementation in C
Fedora Account System Username: jeffreylauribose
Comment 3 Björn "besser82" Esser 2017-07-03 05:57:33 EDT
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Header files in -devel subpackage, if present.
[x]: ldconfig called in %post and %postun if required.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.
[x]: Development (unversioned) .so files in -devel subpackage, if present.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "MIT/X11 (BSD like)", "NTP", "FSF All Permissive", "GPL (v2 or
     later)", "Unknown or generated". 202 files have unknown license.
     Detailed output of licensecheck in
     /home/besser82/vm_shared/fedora/review/1467132-json-c12/licensecheck.txt

     ---> License is fine.

[x]: License file installed when any subpackage combination is installed.
[!]: Package does not own files or directories owned by other packages.
     Note: Dirs in package are owned also by:
     /usr/include/json-c(json-c-devel)

     ---> This will clash with the original json-c package.
          See my comments at the end.

[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[!]: Package does not generate any conflict.

     ---> Files inside this package will conflict with the original
          json-c package.  See my comments at the end.

[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 30720 bytes in 3 files.
[!]: Package complies to the Packaging Guidelines

     ---> Conflicting files.  See my comments at the end.

[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local


===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     json-c12-devel , json-c12-doc , json-c12-debuginfo

     ---> All needed Requires are present.

[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Scriptlets must be sane, if used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.


===== EXTRA items =====

Generic:
[!]: Package should not use obsolete m4 macros
     Note: Some obsoleted macros found, see the attachment.
     See: https://fedorahosted.org/FedoraReview/wiki/AutoTools

     ---> This can possibly be fixed by running `autoupdate -v` before
          invoking autoreconf.

[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: json-c12-0.12.1-2.el7.centos.x86_64.rpm
          json-c12-devel-0.12.1-2.el7.centos.x86_64.rpm
          json-c12-doc-0.12.1-2.el7.centos.noarch.rpm
          json-c12-debuginfo-0.12.1-2.el7.centos.x86_64.rpm
          json-c12-0.12.1-2.el7.centos.src.rpm
json-c12.x86_64: W: incoherent-version-in-changelog 0.12.1-2 ['0.12.1-2.el7.centos', '0.12.1-2.centos']
json-c12.x86_64: W: shared-lib-calls-exit /usr/lib64/libjson-c.so.2.0.2 exit@GLIBC_2.2.5
json-c12.x86_64: W: no-documentation
json-c12-devel.x86_64: W: only-non-binary-in-usr-lib
5 packages and 0 specfiles checked; 0 errors, 4 warnings.


Rpmlint (debuginfo)
-------------------
Checking: json-c12-debuginfo-0.12.1-2.el7.centos.x86_64.rpm
1 packages and 0 specfiles checked; 0 errors, 0 warnings.


Rpmlint (installed packages)
----------------------------
json-c12.x86_64: W: incoherent-version-in-changelog 0.12.1-2 ['0.12.1-2.el7.centos', '0.12.1-2.centos']
json-c12.x86_64: W: shared-lib-calls-exit /usr/lib64/libjson-c.so.2.0.2 exit@GLIBC_2.2.5
json-c12.x86_64: W: no-documentation
json-c12-debuginfo.x86_64: W: only-non-binary-in-usr-lib
4 packages and 0 specfiles checked; 0 errors, 4 warnings.


Requires
--------
json-c12-devel (rpmlib, GLIBC filtered):
    /usr/bin/pkg-config
    json-c12(x86-64)
    libjson-c.so.2()(64bit)

json-c12-doc (rpmlib, GLIBC filtered):

json-c12 (rpmlib, GLIBC filtered):
    /sbin/ldconfig
    libc.so.6()(64bit)
    rtld(GNU_HASH)

json-c12-debuginfo (rpmlib, GLIBC filtered):


Provides
--------
json-c12-devel:
    json-c12-devel
    json-c12-devel(x86-64)
    pkgconfig(json-c)

json-c12-doc:
    json-c12-doc

json-c12:
    json-c12
    json-c12(x86-64)
    libjson-c.so.2()(64bit)

json-c12-debuginfo:
    json-c12-debuginfo
    json-c12-debuginfo(x86-64)


Source checksums
----------------
https://github.com/json-c/json-c/archive/json-c-0.12.1-20160607.tar.gz :
  CHECKSUM(SHA256) this package     : 989e09b99ded277a0a651cd18b81fcb76885fea08769d7a21b6da39fb8a34816
  CHECKSUM(SHA256) upstream package : 989e09b99ded277a0a651cd18b81fcb76885fea08769d7a21b6da39fb8a34816


AutoTools: Obsoleted m4s found
------------------------------
  AM_PROG_LIBTOOL found in: json-c-json-c-0.12.1-20160607/configure.ac:71

---> This can possibly be fixed by running `autoupdate -v` before
     invoking autoreconf.  If autoupdate doesn't work, it should be
     patched in configure.ac


Generated by fedora-review 0.6.1 (f03e4e7) last change: 2016-05-02
Command line :/usr/bin/fedora-review -m epel-7-x86_64 -b 1467132
Buildroot used: epel-7-x86_64
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6


===== Solution =====

Not approved.  Issues are present.


===== Comments and suggestions =====

To avoid conflicting files between this compat-package and the original package, you must patch the buildsystem (Makefile.am) to generate / build the files suffixed the same way as the package is (e.g. libjson-c12.so, libjson-c12.pc).  If you need help doing so, let me know.

If this package should be build for EPEL6 as well, you must drop the 'f' from the switches used with hardlink.
Comment 4 Björn "besser82" Esser 2017-07-03 06:22:19 EDT
For replacing the obsolete macro in configure.ac have a look at this patch [1].


[1]  https://github.com/json-c/json-c/pull/333.patch
Comment 5 Björn "besser82" Esser 2017-07-03 06:41:40 EDT
For properly renaming to avoid conflicts with the original json-c package have a look at this patch [1].


[1]  https://github.com/besser82/json-c/commit/9b0b9f3c00078a0ec7a63eb8a252a24f69ae0922.patch
Comment 6 Björn "besser82" Esser 2017-07-03 06:43:22 EDT
To get those patches applied properly, you need to append `-p 1` to the %autosetup line in the spec file.
Comment 7 jeffrey.lau 2017-07-05 06:03:08 EDT
Thanks Björn.  Here's another go at it:

Spec URL: https://raw.githubusercontent.com/riboseinc/rpm-specs/master/json-c12/json-c12.spec
SRPM URL: https://raw.githubusercontent.com/riboseinc/yum/master/SRPMS/json-c12-0.12.1-3.el7.src.rpm

We incorporated the patches into the spec file as 'sed' commands, which seemed to have removed the issues reported by fedora-review.
Comment 8 Björn "besser82" Esser 2017-07-05 06:22:21 EDT
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Header files in -devel subpackage, if present.
[x]: ldconfig called in %post and %postun if required.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.
[x]: Development (unversioned) .so files in -devel subpackage, if present.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "MIT/X11 (BSD like)", "NTP", "FSF All Permissive", "GPL (v2 or
     later)", "Unknown or generated". 202 files have unknown license.
     Detailed output of licensecheck in
     /home/besser82/vm_shared/fedora/review/1467132-json-c12/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 30720 bytes in 3 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local


===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     json-c12-devel , json-c12-doc , json-c12-debuginfo

     --->  False positive.  Dependencies are fine.

[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Scriptlets must be sane, if used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.


===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Package should not use obsolete m4 macros
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: json-c12-0.12.1-3.el7.centos.x86_64.rpm
          json-c12-devel-0.12.1-3.el7.centos.x86_64.rpm
          json-c12-doc-0.12.1-3.el7.centos.noarch.rpm
          json-c12-debuginfo-0.12.1-3.el7.centos.x86_64.rpm
          json-c12-0.12.1-3.el7.centos.src.rpm
json-c12.x86_64: W: incoherent-version-in-changelog 0.12.1-3 ['0.12.1-3.el7.centos', '0.12.1-3.centos']
json-c12.x86_64: W: shared-lib-calls-exit /usr/lib64/libjson-c12.so.2.0.2 exit@GLIBC_2.2.5
json-c12.x86_64: W: no-documentation
json-c12-devel.x86_64: W: only-non-binary-in-usr-lib
5 packages and 0 specfiles checked; 0 errors, 4 warnings.


Rpmlint (debuginfo)
-------------------
Checking: json-c12-debuginfo-0.12.1-3.el7.centos.x86_64.rpm
1 packages and 0 specfiles checked; 0 errors, 0 warnings.


Rpmlint (installed packages)
----------------------------
json-c12.x86_64: W: incoherent-version-in-changelog 0.12.1-3 ['0.12.1-3.el7.centos', '0.12.1-3.centos']
json-c12.x86_64: W: shared-lib-calls-exit /usr/lib64/libjson-c12.so.2.0.2 exit@GLIBC_2.2.5
json-c12.x86_64: W: no-documentation
json-c12-debuginfo.x86_64: W: only-non-binary-in-usr-lib
4 packages and 0 specfiles checked; 0 errors, 4 warnings.


Requires
--------
json-c12-devel (rpmlib, GLIBC filtered):
    /usr/bin/pkg-config
    json-c12(x86-64)
    libjson-c12.so.2()(64bit)

json-c12-doc (rpmlib, GLIBC filtered):

json-c12 (rpmlib, GLIBC filtered):
    /sbin/ldconfig
    libc.so.6()(64bit)
    rtld(GNU_HASH)

json-c12-debuginfo (rpmlib, GLIBC filtered):


Provides
--------
json-c12-devel:
    json-c12-devel
    json-c12-devel(x86-64)
    pkgconfig(json-c12)

json-c12-doc:
    json-c12-doc

json-c12:
    json-c12
    json-c12(x86-64)
    libjson-c12.so.2()(64bit)

json-c12-debuginfo:
    json-c12-debuginfo
    json-c12-debuginfo(x86-64)


Source checksums
----------------
https://github.com/json-c/json-c/archive/json-c-0.12.1-20160607.tar.gz :
  CHECKSUM(SHA256) this package     : 989e09b99ded277a0a651cd18b81fcb76885fea08769d7a21b6da39fb8a34816
  CHECKSUM(SHA256) upstream package : 989e09b99ded277a0a651cd18b81fcb76885fea08769d7a21b6da39fb8a34816


Generated by fedora-review 0.6.1 (f03e4e7) last change: 2016-05-02
Command line :/usr/bin/fedora-review -D EPEL6=1 -m epel-7-x86_64 -b 1467132
Buildroot used: epel-7-x86_64
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH


===== Solution =====

Package APPROVED!!!  I'd recommend to reset the Release-tag to 1 during import and clear the changelog to just have one entry:

* Mon May 8 2017 Jeffrey Lau <jeffrey.lau@ribose.com> - 0.12.1-1
- Initial compat-package for EPEL >= 6, based on json-c from recent Fedora

Since this is a compat-pkg for EPEL only, you must retire the master branch in dist-git immediately.  It is pretty easy to do:  `fedpkg retire 'Compat-pkg for EPEL, only.'`.  After that you can import the package on the epel7 branch, build it and merge it down to el6 and build it there again.

If you have further questions about how to proceed from now on, you we can discuss this by email.
Comment 9 Gwyn Ciesla 2017-07-06 07:04:52 EDT
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/rpms/json-c12
Comment 10 Fedora Update System 2017-07-06 09:09:26 EDT
json-c12-0.12.1-1.el7 has been submitted as an update to Fedora EPEL 7. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2017-99ae3cbbfb
Comment 11 Fedora Update System 2017-07-07 03:49:19 EDT
json-c12-0.12.1-1.el7 has been pushed to the Fedora EPEL 7 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2017-99ae3cbbfb
Comment 12 Fedora Update System 2017-07-20 01:47:13 EDT
json-c12-0.12.1-1.el6 has been pushed to the Fedora EPEL 6 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2017-0124a2f1c4
Comment 13 Fedora Update System 2017-07-23 14:49:45 EDT
json-c12-0.12.1-1.el7 has been pushed to the Fedora EPEL 7 stable repository. If problems still persist, please make note of it in this bug report.
Comment 14 Fedora Update System 2017-08-03 21:16:25 EDT
json-c12-0.12.1-1.el6 has been pushed to the Fedora EPEL 6 stable repository. If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.